#WPI ECE MQP 003
#Samantha Boyea, Arden Carling
#10/12/2021
#Elements from example by Shawn Hymel (Sparkfun tmp102 example)

import time
import datetime as dt
import matplotlib
import matplotlib.pyplot as plt
import matplotlib.animation as animation
import board
import adafruit_ina260

#matplotlib.use('Agg')

# Create figure for plotting
fig = plt.figure()
ax = fig.add_subplot(1, 1, 1)
xs = []
ys = []

# Initialize communication with ina260
i2c = board.I2C()
ina260 = adafruit_ina260.INA260(i2c)

def read_power():
    power = ina260.power / 1000.0 
    return power
    

# This function is called at 1Hz from FuncAnimation
def animate(i, xs, ys):

    # Add x and y to lists
    xs.append(dt.datetime.now().strftime('%H:%M:%S'))
    ys.append(read_power())

    # Limit x and y lists to 20 items
    xs = xs[-20:]
    ys = ys[-20:]

    # Draw x and y lists
    ax.clear()
    ax.plot(xs, ys)

    # Format plot
    plt.xticks(rotation=45, ha='right')
    plt.subplots_adjust(bottom=0.30)
    plt.title('INA260 Power Over Time')
    plt.ylabel('Power Delivered (Watts)')

# Set up plot to call animate() function periodically
ani = animation.FuncAnimation(fig, animate, fargs=(xs, ys), interval=1000)
plt.show()
